package gov.lbl.kdd.data;

import gov.ornl.csed.csiir.idr.kdd.dataservice.server.models.DataSetQueryRequest.QueryNode;

import java.io.InputStream;
import java.util.List;

import org.junit.After;
import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;


public class KeywordQueryTest {
	
	private List<String> dictionary;
	private int numRequests;

	@Before
	public void load() throws Exception {
		InputStream is = getClass().getResourceAsStream("a131fed5-bab1-3bf6-af68-088b6c684057-keyword.txt");
		dictionary = FileUtil.read(is);
		
		is.close();
		
		numRequests = Integer.parseInt(System.getProperty("NUM_OF_REQUESTS", "1"));
	}
	
	@Test
	public void test() throws Exception {
		int size = numRequests;
		
		List<QueryNode> queries = QueryUtil.createSimpleQueries(dictionary, (size < 0)? dictionary.size() : size);
		DataImpl tester = new DataImpl("KeywordTester", "a131fed5-bab1-3bf6-af68-088b6c684057", null, queries);
		
		for (int i = 0; i < 2; ++i) {
			System.out.println("BEGIN");
			tester.run();
			
			Assert.assertTrue("INCONSISTENT", Integer.valueOf(tester.getConsumer().getInconsistent()) == 0);
			Assert.assertTrue("ERRORS", tester.getConsumer().getErrors() == 0);
			Assert.assertTrue("EXCEPTIONS", tester.getConsumer().getExceptions() == 0);
			System.out.println("END");
		}
	}

	@After
	public void clear() throws Exception {
	}
}
