package gov.lbl.kdd.data;

import java.io.InputStream;
import java.util.ArrayList;
import java.util.List;

import org.junit.After;
import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;


public class RetrieveDocumentTest {
	private List<String> docIds;
	private int numOfDocs;
	
	@Before
	public void load() throws Exception {
		numOfDocs = Integer.parseInt(System.getProperty("NUM_OF_DOCS", "1"));
		InputStream is = getClass().getResourceAsStream("a131fed5-bab1-3bf6-af68-088b6c684057-docid.txt");
		
		docIds = FileUtil.read(is);
		
		is.close();
		
		List<String> temp = new ArrayList<String>();
			
		for (int i = 0; i < numOfDocs; ++i) {
			temp.add(docIds.get(i));
		}
			
		docIds = temp;
	}
	
	@Test
	public void test() throws Exception {
		DocumentImpl tester = new DocumentImpl("DocumentTester", "a131fed5-bab1-3bf6-af68-088b6c684057", docIds);
		
		for (int i = 0; i < 2; ++i) {
			System.out.println("BEGIN");
			tester.run();
			
			Assert.assertTrue("INCONSISTENT", Integer.valueOf(tester.getConsumer().getInconsistent()) == 0);
			Assert.assertTrue("ERRORS", tester.getConsumer().getErrors() == 0);
			Assert.assertTrue("EXCEPTIONS", tester.getConsumer().getExceptions() == 0);
			System.out.println("END");
		}
	}
	
	@After
	public void clear() throws Exception {
	}
}
