import subprocess
import sys
import time

from WorkerArgs import WorkerArgs

class CleanAll:
    def run(self, workerArgsList, user):
        hosts = set()
        
        for workerArgs in workerArgsList: 
            hosts.add(workerArgs.host)
            
        for host in hosts: 
            dest = user +"@" + host
            subprocess.call(["ssh", dest, "ps ax | grep TestKDDDataService.jar | grep -v grep | awk '{print $1}' | xargs kill >& /dev/null"])
            
        time.sleep(2) 
        
        for workerArgs in workerArgsList: 
            dest = user +"@" + workerArgs.host
            port = str(workerArgs.port)
            print "Removing directory KDDDataService-" + port + " on " + workerArgs.host 
            subprocess.call(["ssh", dest, "rm -rf KDDDataService-" + port])
            
if __name__ == '__main__' :
    if len(sys.argv) < 3:
        print "Usage: CleanAll.py commandFile userName"
        sys.exit(1)
        
    print "Cleaning after the experiment ..."
    workerArgsList = []
    f = open(sys.argv[1])
    user = sys.argv[2]
    
    try:
        for line in f:
            workerArgs = WorkerArgs()
            line = line.strip()
            if line == "" or line.startswith("#"):
                continue
            tokens = line.split(',')

            if len(tokens) != 3:
               print "skipping bad command line:" + line
               continue

            workerArgs.setHost(tokens[0])
            workerArgs.setPort(int(tokens[1]));
            workerArgs.setCommand(tokens[2])
            workerArgsList.append(workerArgs)
    finally:
        f.close()

    if len(workerArgsList) == 0:
        print "command file does not contain any commands"
        sys.exit(1)

    runner = CleanAll()
    runner.run(workerArgsList, user)
    print "Done cleaning after the experiment"
    sys.exit(0)
