import sys

from WorkerArgs import WorkerArgs
from Executor import Executor 
from Deploy import Deploy 
from Collect import Collect 
from GenReport import GenReport 
from CleanAll import CleanAll 

if __name__ == '__main__' :
    if len(sys.argv) < 8:
        print "Usage: Conductor.py commandFile userName ToBeDeployedDir numRuns logDir GenReportsJarDir friendlyName"
        sys.exit(1)
        
    workerArgsList = []
    f = open(sys.argv[1])
    user = sys.argv[2]
    dirName = sys.argv[3]
    numRuns = int(sys.argv[4])
    logDirName = sys.argv[5]
    genReportsDir = sys.argv[6]
    friendlyName = sys.argv[7]

    try:
        for line in f:
            workerArgs = WorkerArgs()
            line = line.strip()
            if line == "" or line.startswith("#"):
		continue
            tokens = line.split(',')

            if len(tokens) != 3:
               print "skipping bad command line:" + line
               continue

            workerArgs.setHost(tokens[0])
            workerArgs.setPort(int(tokens[1]));
            workerArgs.setCommand(tokens[2])
            workerArgsList.append(workerArgs)
    finally:
        f.close()

    if len(workerArgsList) == 0:
	print "command file does not contain any commands"
        sys.exit(1)

    deploy = Deploy()
    deploy.run(workerArgsList, user, dirName)
    executor = Executor();
    executor.run(workerArgsList, user, numRuns)
    collect = Collect()
    collect.run(workerArgsList, user, logDirName)
    genReport = GenReport();
    genReport.run(genReportsDir, logDirName, friendlyName)
    cleanAll = CleanAll()
    cleanAll.run(workerArgsList, user)
    sys.exit(0)
