import subprocess
import sys
import time
import os

from WorkerArgs import WorkerArgs

class Deploy:
    def run(self, workerArgsList, user, dirName):
        hosts = set()
        
        for workerArgs in workerArgsList: 
            hosts.add(workerArgs.host)
            
        for host in hosts: 
            dest = user +"@" + host
            subprocess.call(["ssh", dest, "ps ax | grep TestKDDDataService.jar | grep -v grep | awk '{print $1}' | xargs kill >& /dev/null"])

        time.sleep(2) 
        
        for workerArgs in workerArgsList: 
            dest = user +"@" + workerArgs.host
            port = str(workerArgs.port)
            subprocess.call(["ssh", dest, "rm -rf KDDDataService-" + port])
	    print "copying to " + dest + " " + port
            os.system('scp -r "%s" "%s:%s"' % (dirName, dest, "KDDDataService-" + port) )
           
if __name__ == '__main__' :
    if len(sys.argv) < 4:
        print "Usage: Deploy.py commandFile userName toBeDepoloyedDir"
        sys.exit(1)
        
    workerArgsList = []
    f = open(sys.argv[1])
    user = sys.argv[2]
    dirName = sys.argv[3]
    
    try:
        for line in f:
            workerArgs = WorkerArgs()
            line = line.strip()
            if line == "" or line.startswith("#"):
                continue
            tokens = line.split(',')

            if len(tokens) != 3:
               print "skipping bad command line:" + line
               continue

            workerArgs.setHost(tokens[0])
            workerArgs.setPort(int(tokens[1]));
            workerArgs.setCommand(tokens[2])
            workerArgsList.append(workerArgs)
    finally:
        f.close()

    if len(workerArgsList) == 0:
        print "command file does not contain any commands"
        sys.exit(1)

    deploy = Deploy()
    deploy.run(workerArgsList, user, dirName)
    sys.exit(0)
