import socket
import threading
import sys
import subprocess
import time

from WorkerArgs import WorkerArgs

def sendCommand(lock, host, port, command):
    client = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
    client.settimeout(10)
    client.connect((host, port))
    client.settimeout(None)
    client.send(command + '\n')
    resp = client.makefile().readline()
    lock.acquire()
    print host + ":" + str(port) + ":" + command + ":" + resp.strip()
    lock.release()

class Runner:
    def run(self, workerArgsList, user):
        for workerArgs in workerArgsList:
            dest = user +"@" + workerArgs.host
            port = str(workerArgs.port)
            print "starting musician on " + workerArgs.host + " with " + port
            process=subprocess.Popen(["ssh", dest, "KDDDataService-" + port + "/runMusician " + port], stderr=subprocess.PIPE)
            #process=subprocess.Popen(["ssh", dest, "cd KDDDataService-" + port + ";java -jar TestKDDDataService.jar " + port + " &"], stderr=subprocess.PIPE)
            process.poll()

class Worker ( threading.Thread ) :
    def setLock(self, lock):
        self.lock = lock 

    def setHost(self, host):
        self.host = host 

    def setPort(self, port):
        self.port = port
        
    def setCommand(self, command):
        self.command = command
        
    def run (self):
        sendCommand(self.lock, self.host, self.port, self.command)
        
class Executor:
    def run(self, workerArgsList, user, numRuns):
    	runner = Runner()
    	runner.run(workerArgsList, user)
        time.sleep(2) 
        lock = threading.Lock()
    
        for workerArgs in workerArgsList:
            sendCommand(lock, workerArgs.host, workerArgs.port, "init " + workerArgs.command)
    
        workers = []
        i = 1;
    
        while i <= numRuns:
            print "BEGIN RUN #" + str(i)
            for workerArgs in workerArgsList:
                worker = Worker()
                workers.append(worker)
		worker.setLock(lock)
                worker.setHost(workerArgs.host);
                worker.setPort(workerArgs.port);
                worker.setCommand("run");
                worker.start()
            
            for worker in workers:
                worker.join()
            
            print "END RUN #" + str(i)
            i = i + 1
        
        for workerArgs in workerArgsList:
            sendCommand(lock, workerArgs.host, workerArgs.port, "exit")

if __name__ == '__main__' :
    if len(sys.argv) < 4:
        print "Usage: Executor.py commandFile userName numRuns"
        sys.exit(1)

    workerArgsList = []
    f = open(sys.argv[1])
    user = sys.argv[2]
    numRuns = int(sys.argv[3])

    try:
        for line in f:
            workerArgs = WorkerArgs()
            line = line.strip()
            if line == "" or line.startswith("#"):
                continue
            tokens = line.split(',')

            if len(tokens) != 3:
               print "skipping bad command line:" + line
               continue

            workerArgs.setHost(tokens[0])
            workerArgs.setPort(int(tokens[1]));
            workerArgs.setCommand(tokens[2])
            workerArgsList.append(workerArgs)
    finally:
        f.close()

    executor = Executor();
    executor.run(workerArgsList, user, numRuns)
